<?php

namespace App\ViewModels\Pagamento\PagamentoComandaPagamentoRegistrationViewModel;

use App\Utils\Builder;

class PagamentoComandaPagamentoViewModelBuilder implements Builder {
	protected $id;
	protected $comanda_fechamento_id;
	protected $valor;
	protected $forma_pagamento_id;
	protected $dbtcrd;
	protected $maquineta;
	protected $bandeira;
	protected $codauth;
	protected $dinheiro;
	protected $troco;
	protected $chavepix;
	protected $observacao;
	protected $criado_por;
	protected $data_criacao;
	protected $hora_criacao;
	protected $atualizado_por;
	protected $data_atualizacao;
	protected $hora_atualizacao;
	protected $credito_cliente;

	public function build(): PagamentoComandaPagamentoViewModel {

		$pagamentoComanda_vm = new PagamentoComandaPagamentoViewModel();

		$pagamentoComanda_vm->setId( $this->id );
		$pagamentoComanda_vm->setComandaFechamentoId( $this->comanda_fechamento_id );
		$pagamentoComanda_vm->setValor( $this->valor );
		$pagamentoComanda_vm->setDinheiro( $this->dinheiro );
		$pagamentoComanda_vm->setTroco( $this->troco );
		$pagamentoComanda_vm->setFormaPagamentoId( $this->forma_pagamento_id );
		$pagamentoComanda_vm->setDbtcrd( $this->dbtcrd );
		$pagamentoComanda_vm->setMaquineta( $this->maquineta );
		$pagamentoComanda_vm->setBandeira( $this->bandeira );
		$pagamentoComanda_vm->setCodauth( $this->codauth );
		$pagamentoComanda_vm->setObservacao( $this->observacao );
		$pagamentoComanda_vm->setCriado_por( $this->criado_por );
		$pagamentoComanda_vm->setDataCriacao( $this->data_criacao );
		$pagamentoComanda_vm->setHoraCriacao( $this->hora_criacao );
		$pagamentoComanda_vm->setAtualizado_por( $this->atualizado_por );
		$pagamentoComanda_vm->setDataAtualizacao( $this->data_atualizacao );
		$pagamentoComanda_vm->setHoraAtualizacao( $this->hora_atualizacao );
		$pagamentoComanda_vm->setCreditocliente( $this->credito_cliente ?? [ ]);

		return $pagamentoComanda_vm;

	}

	/**
	 *
	 * @param mixed $id
	 */
	public function setId($id) {

		$this->id = $id;
		return $this;

	}

	/**
	 *
	 * @param mixed $fechamento_id
	 */
	public function setComandaFechamentoId($comanda_fechamento_id) {

		$this->comanda_fechamento_id = $comanda_fechamento_id;
		return $this;

	}

	/**
	 *
	 * @param mixed $valor
	 */
	public function setValor($valor) {

		$this->valor = $valor;
		return $this;

	}

	/**
	 *
	 * @param mixed $forma_pagamento_id
	 */
	public function setFormaPagamentoId($forma_pagamento_id) {

		$this->forma_pagamento_id = $forma_pagamento_id;
		return $this;

	}

	/**
	 *
	 * @param mixed $dbtcrd
	 */
	public function setDbtcrd($dbtcrd) {

		$this->dbtcrd = $dbtcrd;
		return $this;

	}

	/**
	 *
	 * @param mixed $maquineta
	 */
	public function setMaquineta($maquineta) {

		$this->maquineta = $maquineta;
		return $this;

	}

	/**
	 *
	 * @param mixed $bandeira
	 */
	public function setBandeira($bandeira) {

		$this->bandeira = $bandeira;
		return $this;

	}

	/**
	 *
	 * @param mixed $codauth
	 */
	public function setCodauth($codauth) {

		$this->codauth = $codauth;
		return $this;

	}

	/**
	 *
	 * @param mixed $dinheiro
	 */
	public function setDinheiro($dinheiro) {

		$this->dinheiro = $dinheiro;
		return $this;

	}

	/**
	 *
	 * @param mixed $troco
	 */
	public function setTroco($troco) {

		$this->troco = $troco;
		return $this;

	}

	/**
	 *
	 * @param mixed $chavepix
	 */
	public function setChavePix($chavepix) {

		$this->chavepix = $chavepix;
		return $this;

	}

	/**
	 *
	 * @param mixed $observacao
	 */
	public function setObservacao($observacao) {

		$this->observacao = $observacao;
		return $this;

	}

	/**
	 *
	 * @param mixed $criado_por
	 */
	public function setCriado_por($criado_por) {

		$this->criado_por = $criado_por;
		return $this;

	}

	/**
	 *
	 * @param mixed $data_criacao
	 */
	public function setDataCriacao($data_criacao) {

		$this->data_criacao = $data_criacao;
		return $this;

	}

	/**
	 *
	 * @param mixed $hora_criacao
	 */
	public function setHoraCriacao($hora_criacao) {

		$this->hora_criacao = $hora_criacao;
		return $this;

	}

	/**
	 *
	 * @param mixed $atualizado_por
	 */
	public function setAtualizado_por($atualizado_por) {

		$this->atualizado_por = $atualizado_por;
		return $this;

	}

	/**
	 *
	 * @param mixed $data_atualizacao
	 */
	public function setDataAtualizacao($data_atualizacao) {

		$this->data_atualizacao = $data_atualizacao;
		return $this;

	}

	/**
	 *
	 * @param mixed $hora_atualizacao
	 */
	public function setHoraAtualizacao($hora_atualizacao) {

		$this->hora_atualizacao = $hora_atualizacao;
		return $this;

	}

	/**
	 *
	 * @param mixed $hora_atualizacao
	 */
	public function setCreditoCliente($credito_cliente) {

		$this->credito_cliente = $credito_cliente;
		return $this;

	}

}

